blob: 7ab8af47a56f8cd5b1083292c0f00522f66c04f6 [file] [log] [blame]
Jonathan Niederc74c7202013-11-25 13:03:06 -08001# Test framework for git. See t/README for usage.
Junio C Hamanoe1970ce2005-05-13 22:50:32 -07002#
3# Copyright (c) 2005 Junio C Hamano
4#
Michal Sojka64b90322010-04-16 15:53:59 +02005# This program is free software: you can redistribute it and/or modify
6# it under the terms of the GNU General Public License as published by
7# the Free Software Foundation, either version 2 of the License, or
8# (at your option) any later version.
9#
10# This program is distributed in the hope that it will be useful,
11# but WITHOUT ANY WARRANTY; without even the implied warranty of
12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13# GNU General Public License for more details.
14#
15# You should have received a copy of the GNU General Public License
16# along with this program. If not, see http://www.gnu.org/licenses/ .
Junio C Hamanoe1970ce2005-05-13 22:50:32 -070017
Junio C Hamano3c8f12c2012-06-24 22:01:35 -070018# Test the binaries we have just built. The tests are kept in
19# t/ subdirectory and are run in 'trash directory' subdirectory.
20if test -z "$TEST_DIRECTORY"
21then
22 # We allow tests to override this, in case they want to run tests
23 # outside of t/, e.g. for running tests on the test library
24 # itself.
25 TEST_DIRECTORY=$(pwd)
Felipe Contreras85176d72013-11-17 23:12:43 -050026else
27 # ensure that TEST_DIRECTORY is an absolute path so that it
28 # is valid even if the current working directory is changed
29 TEST_DIRECTORY=$(cd "$TEST_DIRECTORY" && pwd) || exit 1
Junio C Hamano3c8f12c2012-06-24 22:01:35 -070030fi
31if test -z "$TEST_OUTPUT_DIRECTORY"
32then
33 # Similarly, override this to store the test-results subdir
34 # elsewhere
35 TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
36fi
37GIT_BUILD_DIR="$TEST_DIRECTORY"/..
38
Jeff Kingd0cc5792017-07-10 09:24:35 -040039# If we were built with ASAN, it may complain about leaks
40# of program-lifetime variables. Disable it by default to lower
41# the noise level. This needs to happen at the start of the script,
42# before we even do our "did we build git yet" check (since we don't
43# want that one to complain to stderr).
Jeff Kingbf1ce902017-07-10 09:24:39 -040044: ${ASAN_OPTIONS=detect_leaks=0:abort_on_error=1}
Jeff Kingd0cc5792017-07-10 09:24:35 -040045export ASAN_OPTIONS
46
Jeff King85b81b32017-09-05 09:04:04 -040047# If LSAN is in effect we _do_ want leak checking, but we still
48# want to abort so that we notice the problems.
49: ${LSAN_OPTIONS=abort_on_error=1}
50export LSAN_OPTIONS
51
Ramkumar Ramachandra2006f0a2012-09-17 22:36:19 +053052################################################################
53# It appears that people try to run tests without building...
54"$GIT_BUILD_DIR/git" >/dev/null
55if test $? != 1
56then
57 echo >&2 'error: you do not seem to have built git yet.'
58 exit 1
59fi
60
Junio C Hamano3c8f12c2012-06-24 22:01:35 -070061. "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
62export PERL_PATH SHELL_PATH
63
Ramkumar Ramachandra4cde5192012-09-22 10:25:10 +053064# if --tee was passed, write the output not only to the terminal, but
65# additionally to the file test-results/$BASENAME.out, too.
66case "$GIT_TEST_TEE_STARTED, $* " in
67done,*)
68 # do not redirect again
69 ;;
Jeff King452320f2016-10-21 06:48:00 -040070*' --tee '*|*' --va'*|*' --verbose-log '*)
John Keeping2d14e132013-04-29 19:16:21 +010071 mkdir -p "$TEST_OUTPUT_DIRECTORY/test-results"
72 BASE="$TEST_OUTPUT_DIRECTORY/test-results/$(basename "$0" .sh)"
Jeff King452320f2016-10-21 06:48:00 -040073
74 # Make this filename available to the sub-process in case it is using
75 # --verbose-log.
76 GIT_TEST_TEE_OUTPUT_FILE=$BASE.out
77 export GIT_TEST_TEE_OUTPUT_FILE
78
79 # Truncate before calling "tee -a" to get rid of the results
80 # from any previous runs.
81 >"$GIT_TEST_TEE_OUTPUT_FILE"
82
Jeff King3f824e92017-12-08 05:47:22 -050083 (GIT_TEST_TEE_STARTED=done ${TEST_SHELL_PATH} "$0" "$@" 2>&1;
Jeff King452320f2016-10-21 06:48:00 -040084 echo $? >"$BASE.exit") | tee -a "$GIT_TEST_TEE_OUTPUT_FILE"
Jeff King925bdc92016-10-21 06:42:10 -040085 test "$(cat "$BASE.exit")" = 0
Ramkumar Ramachandra4cde5192012-09-22 10:25:10 +053086 exit
87 ;;
88esac
89
Junio C Hamanoe1970ce2005-05-13 22:50:32 -070090# For repeatability, reset the environment to known value.
Richard Hansend5c1b7c2015-06-17 17:11:21 -040091# TERM is sanitized below, after saving color control sequences.
Junio C Hamanoe1970ce2005-05-13 22:50:32 -070092LANG=C
Junio C Hamano899460f2005-10-09 21:58:02 -070093LC_ALL=C
Pavel Roskind9bdd392005-08-10 22:10:01 -040094PAGER=cat
Junio C Hamanoe1970ce2005-05-13 22:50:32 -070095TZ=UTC
Richard Hansend5c1b7c2015-06-17 17:11:21 -040096export LANG LC_ALL PAGER TZ
Eric Wong8ff99e72006-07-11 12:01:54 -070097EDITOR=:
Stefano Lattarini661bfd12012-03-02 19:48:36 +010098# A call to "unset" with no arguments causes at least Solaris 10
99# /usr/xpg4/bin/sh and /bin/ksh to bail out. So keep the unsets
100# deriving from the command substitution clustered with the other
101# ones.
Junio C Hamano3c8f12c2012-06-24 22:01:35 -0700102unset VISUAL EMAIL LANGUAGE COLUMNS $("$PERL_PATH" -e '
Jonathan Nieder95a1d122011-03-15 05:10:45 -0500103 my @env = keys %ENV;
Jens Lehmann730477f2011-03-28 21:16:09 +0200104 my $ok = join("|", qw(
105 TRACE
106 DEBUG
Jens Lehmann730477f2011-03-28 21:16:09 +0200107 TEST
108 .*_TEST
109 PROVE
110 VALGRIND
René Scharfeac001282013-01-06 18:47:57 +0100111 UNZIP
Nguyễn Thái Ngọc Duyedb54082013-01-15 20:50:56 +0700112 PERF_
Jeff Kinge2a0ccc2014-05-22 05:28:50 -0400113 CURL_VERBOSE
Elia Pinto4527aa12016-09-05 10:24:42 +0000114 TRACE_CURL
Jens Lehmann730477f2011-03-28 21:16:09 +0200115 ));
116 my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
Jonathan Nieder95a1d122011-03-15 05:10:45 -0500117 print join("\n", @vars);
118')
Genki Sky7976e902018-02-15 21:46:04 -0500119unset XDG_CACHE_HOME
Jeff King5adf84e2012-07-24 07:53:05 -0400120unset XDG_CONFIG_HOME
Benoit Person8bade1e2013-07-04 22:38:55 +0200121unset GITPERLLIB
Junio C Hamano29e55cd2006-02-10 19:11:23 -0800122GIT_AUTHOR_EMAIL=author@example.com
123GIT_AUTHOR_NAME='A U Thor'
Junio C Hamano29e55cd2006-02-10 19:11:23 -0800124GIT_COMMITTER_EMAIL=committer@example.com
125GIT_COMMITTER_NAME='C O Mitter'
Shawn O. Pearce8d0fc482007-02-04 00:45:47 -0500126GIT_MERGE_VERBOSITY=5
Junio C Hamanof8246282012-01-10 22:44:45 -0800127GIT_MERGE_AUTOEDIT=no
128export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
Junio C Hamano29e55cd2006-02-10 19:11:23 -0800129export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
130export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
Jonathan Niederd33738d2009-11-11 17:56:07 -0600131export EDITOR
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700132
Karsten Blees124647c2014-07-12 02:03:01 +0200133# Tests using GIT_TRACE typically don't want <timestamp> <file>:<line> output
134GIT_TRACE_BARE=1
135export GIT_TRACE_BARE
136
Thomas Gummerer5d9fc882014-02-23 21:49:58 +0100137if test -n "${TEST_GIT_INDEX_VERSION:+isset}"
138then
139 GIT_INDEX_VERSION="$TEST_GIT_INDEX_VERSION"
140 export GIT_INDEX_VERSION
141fi
142
Elia Pintoa731fa92012-09-14 09:54:22 -0700143# Add libc MALLOC and MALLOC_PERTURB test
144# only if we are not executing the test with valgrind
Junio C Hamano1b3185f2012-09-14 20:38:24 -0700145if expr " $GIT_TEST_OPTS " : ".* --valgrind " >/dev/null ||
René Scharfeee1431b2012-09-26 22:16:39 +0200146 test -n "$TEST_NO_MALLOC_CHECK"
Junio C Hamano1b3185f2012-09-14 20:38:24 -0700147then
148 setup_malloc_check () {
149 : nothing
150 }
151 teardown_malloc_check () {
152 : nothing
153 }
154else
155 setup_malloc_check () {
156 MALLOC_CHECK_=3 MALLOC_PERTURB_=165
157 export MALLOC_CHECK_ MALLOC_PERTURB_
158 }
159 teardown_malloc_check () {
160 unset MALLOC_CHECK_ MALLOC_PERTURB_
161 }
162fi
Elia Pintoa731fa92012-09-14 09:54:22 -0700163
Junio C Hamano886a3902007-04-24 11:21:47 -0700164# Protect ourselves from common misconfiguration to export
165# CDPATH into the environment
166unset CDPATH
167
Bert Wesarg5565f472009-11-18 17:15:19 +0100168unset GREP_OPTIONS
René Scharfeac001282013-01-06 18:47:57 +0100169unset UNZIP
Bert Wesarg5565f472009-11-18 17:15:19 +0100170
Robin Rosenberg3d5c0cc2006-09-23 00:35:20 +0200171case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
Ramsay Jones1c0cc752012-09-01 19:11:49 +01001721|2|true)
Jeff King025232e2015-03-13 00:50:56 -0400173 GIT_TRACE=4
Ramsay Jones1c0cc752012-09-01 19:11:49 +0100174 ;;
Christian Couder6ce4e612006-09-02 18:23:48 +0200175esac
176
Junio C Hamanocd3c0952009-09-20 11:10:14 -0700177# Convenience
178#
Charles Bailey5555a2a2017-11-12 15:25:23 +0000179# A regexp to match 5, 35 and 40 hexdigits
Junio C Hamanocd3c0952009-09-20 11:10:14 -0700180_x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
Charles Bailey5555a2a2017-11-12 15:25:23 +0000181_x35="$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
182_x40="$_x35$_x05"
Junio C Hamanocd3c0952009-09-20 11:10:14 -0700183
Junio C Hamano3749fde2011-04-23 22:34:13 -0700184# Zero SHA-1
185_z40=0000000000000000000000000000000000000000
186
Nguyễn Thái Ngọc Duyf9e7d9f2016-07-16 07:06:24 +0200187EMPTY_TREE=4b825dc642cb6eb9a060e54bf8d69288fbee4904
Nguyễn Thái Ngọc Duy378932d2016-07-16 07:06:25 +0200188EMPTY_BLOB=e69de29bb2d1d6434b8b29ae775ad8c2e48c5391
Nguyễn Thái Ngọc Duyf9e7d9f2016-07-16 07:06:24 +0200189
Junio C Hamano3f4ab622011-08-08 11:51:00 -0700190# Line feed
191LF='
192'
193
Jeff Kinga42643a2014-12-15 18:15:20 -0500194# UTF-8 ZERO WIDTH NON-JOINER, which HFS+ ignores
195# when case-folding filenames
196u200c=$(printf '\342\200\214')
197
Charles Bailey5555a2a2017-11-12 15:25:23 +0000198export _x05 _x35 _x40 _z40 LF u200c EMPTY_TREE EMPTY_BLOB
Thomas Rast342e9ef2012-02-17 11:25:09 +0100199
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700200# Each test should start with something like this, after copyright notices:
201#
202# test_description='Description of this test...
203# This test checks if command xyzzy does the right thing...
204# '
205# . ./test-lib.sh
Richard Hansend5c1b7c2015-06-17 17:11:21 -0400206test "x$TERM" != "xdumb" && (
Richard Hansenca92a662015-06-17 15:06:25 -0400207 test -t 1 &&
208 tput bold >/dev/null 2>&1 &&
209 tput setaf 1 >/dev/null 2>&1 &&
210 tput sgr0 >/dev/null 2>&1
211 ) &&
212 color=t
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700213
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700214while test "$#" -ne 0
215do
216 case "$1" in
217 -d|--d|--de|--deb|--debu|--debug)
218 debug=t; shift ;;
Junio C Hamano886856a2005-05-14 00:24:27 -0700219 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
220 immediate=t; shift ;;
Lea Wiemann5e2c08c2008-06-17 03:29:02 +0200221 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
Junio C Hamano91e80b92009-02-18 11:17:27 -0800222 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
Ilya Bobyr0445e6f2014-04-30 02:50:44 -0700223 -r)
224 shift; test "$#" -ne 0 || {
225 echo 'error: -r requires an argument' >&2;
226 exit 1;
227 }
228 run_list=$1; shift ;;
229 --run=*)
SZEDER Gábor0ff74102016-04-22 22:32:21 +0200230 run_list=${1#--*=}; shift ;;
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700231 -h|--h|--he|--hel|--help)
Michele Ballabio570f3222007-11-10 15:17:25 +0100232 help=t; shift ;;
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700233 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
234 verbose=t; shift ;;
Thomas Rastff09af32013-06-23 20:12:56 +0200235 --verbose-only=*)
SZEDER Gábor0ff74102016-04-22 22:32:21 +0200236 verbose_only=${1#--*=}
Thomas Rastff09af32013-06-23 20:12:56 +0200237 shift ;;
Pierre Habouzit1ece1272007-10-24 22:03:39 +0200238 -q|--q|--qu|--qui|--quie|--quiet)
Ævar Arnfjörð Bjarmason092c4332010-07-31 16:40:05 +0000239 # Ignore --quiet under a TAP::Harness. Saying how many tests
240 # passed without the ok/not ok details is always an error.
241 test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
Matthew Ogilviee4597aa2009-12-02 22:14:06 -0700242 --with-dashes)
243 with_dashes=t; shift ;;
Pierre Habouzit55db1df2007-10-24 22:03:38 +0200244 --no-color)
Clemens Buchacherfaa4bc32008-02-27 20:28:45 +0100245 color=; shift ;;
Johannes Schindelin4e1be632009-02-04 00:25:59 +0100246 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
Thomas Rast952af352013-03-31 10:00:16 +0200247 valgrind=memcheck
248 shift ;;
249 --valgrind=*)
SZEDER Gábor0ff74102016-04-22 22:32:21 +0200250 valgrind=${1#--*=}
Thomas Rast952af352013-03-31 10:00:16 +0200251 shift ;;
Thomas Rast5dfc3682013-06-23 20:12:57 +0200252 --valgrind-only=*)
SZEDER Gábor0ff74102016-04-22 22:32:21 +0200253 valgrind_only=${1#--*=}
Thomas Rast5dfc3682013-06-23 20:12:57 +0200254 shift ;;
Johannes Schindelin44138552009-02-04 00:26:12 +0100255 --tee)
256 shift ;; # was handled already
Jeff Kingf423ef52009-08-09 04:39:45 -0400257 --root=*)
SZEDER Gábor0ff74102016-04-22 22:32:21 +0200258 root=${1#--*=}
Jeff Kingf423ef52009-08-09 04:39:45 -0400259 shift ;;
Jeff Kingbb79af92015-03-20 06:05:48 -0400260 --chain-lint)
261 GIT_TEST_CHAIN_LINT=1
262 shift ;;
263 --no-chain-lint)
264 GIT_TEST_CHAIN_LINT=0
265 shift ;;
Jeff Kinga136f6d2014-10-10 02:47:27 -0400266 -x)
SZEDER Gábor5fc98e72018-02-24 00:39:42 +0100267 # Some test scripts can't be reliably traced with '-x',
268 # unless the test is run with a Bash version supporting
269 # BASH_XTRACEFD (introduced in Bash v4.1). Check whether
270 # this test is marked as such, and ignore '-x' if it
271 # isn't executed with a suitable Bash version.
272 if test -z "$test_untraceable" || {
273 test -n "$BASH_VERSION" && {
274 test ${BASH_VERSINFO[0]} -gt 4 || {
275 test ${BASH_VERSINFO[0]} -eq 4 &&
276 test ${BASH_VERSINFO[1]} -ge 1
277 }
278 }
279 }
280 then
281 trace=t
282 else
283 echo >&2 "warning: ignoring -x; '$0' is untraceable without BASH_XTRACEFD"
284 fi
Jeff Kinga136f6d2014-10-10 02:47:27 -0400285 shift ;;
Jeff King452320f2016-10-21 06:48:00 -0400286 --verbose-log)
287 verbose_log=t
288 shift ;;
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700289 *)
Clemens Buchacher1f729dc2009-06-01 14:14:40 +0200290 echo "error: unknown test option '$1'" >&2; exit 1 ;;
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700291 esac
292done
293
Thomas Rast26a07302013-10-19 23:06:07 +0200294if test -n "$valgrind_only"
Thomas Rast5dfc3682013-06-23 20:12:57 +0200295then
296 test -z "$valgrind" && valgrind=memcheck
297 test -z "$verbose" && verbose_only="$valgrind_only"
298elif test -n "$valgrind"
299then
Jeff King88c6e9d2017-09-05 09:03:54 -0400300 test -z "$verbose_log" && verbose=t
Thomas Rast5dfc3682013-06-23 20:12:57 +0200301fi
Thomas Rast952af352013-03-31 10:00:16 +0200302
Jeff Kingf5ba2de2017-12-08 05:47:17 -0500303if test -n "$trace" && test -z "$verbose_log"
304then
305 verbose=t
306fi
307
Richard Hansenca92a662015-06-17 15:06:25 -0400308if test -n "$color"
309then
Richard Hansend5c1b7c2015-06-17 17:11:21 -0400310 # Save the color control sequences now rather than run tput
311 # each time say_color() is called. This is done for two
312 # reasons:
313 # * TERM will be changed to dumb
314 # * HOME will be changed to a temporary directory and tput
315 # might need to read ~/.terminfo from the original HOME
316 # directory to get the control sequences
317 # Note: This approach assumes the control sequences don't end
318 # in a newline for any terminal of interest (command
319 # substitutions strip trailing newlines). Given that most
320 # (all?) terminals in common use are related to ECMA-48, this
321 # shouldn't be a problem.
322 say_color_error=$(tput bold; tput setaf 1) # bold red
323 say_color_skip=$(tput setaf 4) # blue
324 say_color_warn=$(tput setaf 3) # brown/yellow
325 say_color_pass=$(tput setaf 2) # green
326 say_color_info=$(tput setaf 6) # cyan
327 say_color_reset=$(tput sgr0)
328 say_color_="" # no formatting for normal text
Richard Hansenca92a662015-06-17 15:06:25 -0400329 say_color () {
Richard Hansend5c1b7c2015-06-17 17:11:21 -0400330 test -z "$1" && test -n "$quiet" && return
331 eval "say_color_color=\$say_color_$1"
Richard Hansenca92a662015-06-17 15:06:25 -0400332 shift
Richard Hansend5c1b7c2015-06-17 17:11:21 -0400333 printf "%s\\n" "$say_color_color$*$say_color_reset"
Richard Hansenca92a662015-06-17 15:06:25 -0400334 }
335else
336 say_color() {
337 test -z "$1" && test -n "$quiet" && return
338 shift
339 printf "%s\n" "$*"
340 }
341fi
342
Richard Hansend5c1b7c2015-06-17 17:11:21 -0400343TERM=dumb
344export TERM
345
Pierre Habouzit55db1df2007-10-24 22:03:38 +0200346error () {
347 say_color error "error: $*"
Clemens Buchacher6e7b5aa2009-06-01 14:14:41 +0200348 GIT_EXIT_OK=t
Pierre Habouzit55db1df2007-10-24 22:03:38 +0200349 exit 1
350}
351
352say () {
353 say_color info "$*"
354}
355
Jeff King614fe012016-10-22 00:45:06 -0400356if test -n "$HARNESS_ACTIVE"
357then
358 if test "$verbose" = t || test -n "$verbose_only"
359 then
360 printf 'Bail out! %s\n' \
361 'verbose mode forbidden under TAP harness; try --verbose-log'
362 exit 1
363 fi
364fi
365
Michele Ballabio570f3222007-11-10 15:17:25 +0100366test "${test_description}" != "" ||
367error "Test script did not set test_description."
368
369if test "$help" = "t"
370then
Uwe Storbeckcb1aefd2014-03-18 01:14:11 +0100371 printf '%s\n' "$test_description"
Michele Ballabio570f3222007-11-10 15:17:25 +0100372 exit 0
373fi
374
Pavel Roskin4d9d62f2005-08-10 23:56:21 -0400375exec 5>&1
Jeff King781f76b2011-12-15 01:55:29 -0500376exec 6<&0
SZEDER Gábor4ecae3c2017-03-18 17:13:59 +0100377exec 7>&2
Jeff King452320f2016-10-21 06:48:00 -0400378if test "$verbose_log" = "t"
379then
380 exec 3>>"$GIT_TEST_TEE_OUTPUT_FILE" 4>&3
381elif test "$verbose" = "t"
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700382then
383 exec 4>&2 3>&1
384else
385 exec 4>/dev/null 3>/dev/null
386fi
387
Jeff Kingd88785e2016-05-11 09:44:04 -0400388# Send any "-x" output directly to stderr to avoid polluting tests
389# which capture stderr. We can do this unconditionally since it
390# has no effect if tracing isn't turned on.
391#
392# Note that this sets up the trace fd as soon as we assign the variable, so it
393# must come after the creation of descriptor 4 above. Likewise, we must never
394# unset this, as it has the side effect of closing descriptor 4, which we
395# use to show verbose tests to the user.
396#
397# Note also that we don't need or want to export it. The tracing is local to
398# this shell, and we would not want to influence any shells we exec.
399BASH_XTRACEFD=4
400
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700401test_failure=0
402test_count=0
Junio C Hamano41ac4142008-02-01 01:50:53 -0800403test_fixed=0
404test_broken=0
Sverre Rabbelier2d84e9f2008-06-08 16:04:33 +0200405test_success=0
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700406
Ævar Arnfjörð Bjarmasond998bd42010-06-24 17:44:46 +0000407test_external_has_tap=0
408
Clemens Buchacherfaa4bc32008-02-27 20:28:45 +0100409die () {
Clemens Buchacher6e7b5aa2009-06-01 14:14:41 +0200410 code=$?
411 if test -n "$GIT_EXIT_OK"
412 then
413 exit $code
414 else
415 echo >&5 "FATAL: Unexpected exit with code $code"
416 exit 1
417 fi
Clemens Buchacherfaa4bc32008-02-27 20:28:45 +0100418}
419
Clemens Buchacher6e7b5aa2009-06-01 14:14:41 +0200420GIT_EXIT_OK=
Markus Heidelberg35641312009-01-20 00:43:26 +0100421trap 'die' EXIT
Jeff Kingda706542015-03-13 00:48:48 -0400422trap 'exit $?' INT
Pavel Roskin41184272005-08-11 12:00:40 -0400423
Thomas Rast12a29b12012-02-17 11:25:08 +0100424# The user-facing functions are loaded from a separate file so that
425# test_perf subshells can have them too
Junio C Hamano3c8f12c2012-06-24 22:01:35 -0700426. "$TEST_DIRECTORY/test-lib-functions.sh"
Jonathan Nieder05236a52010-10-17 02:36:58 +0800427
Junio C Hamano886856a2005-05-14 00:24:27 -0700428# You are not expected to call test_ok_ and test_failure_ directly, use
Torstein Hegge3fa36662013-10-27 10:56:33 +0100429# the test_expect_* functions instead.
Junio C Hamano886856a2005-05-14 00:24:27 -0700430
431test_ok_ () {
Johannes Sixtd5d9de12009-02-05 20:59:27 +0100432 test_success=$(($test_success + 1))
Thomas Rast633fe502013-10-19 23:06:08 +0200433 say_color "" "ok $test_count - $@"
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700434}
435
Junio C Hamano886856a2005-05-14 00:24:27 -0700436test_failure_ () {
Johannes Sixtd5d9de12009-02-05 20:59:27 +0100437 test_failure=$(($test_failure + 1))
Thomas Rast633fe502013-10-19 23:06:08 +0200438 say_color error "not ok $test_count - $1"
Junio C Hamanobf0dd8a2005-07-22 19:09:34 -0700439 shift
Uwe Storbeckcb1aefd2014-03-18 01:14:11 +0100440 printf '%s\n' "$*" | sed -e 's/^/# /'
Clemens Buchacher6e7b5aa2009-06-01 14:14:41 +0200441 test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
Junio C Hamano886856a2005-05-14 00:24:27 -0700442}
443
Junio C Hamano41ac4142008-02-01 01:50:53 -0800444test_known_broken_ok_ () {
Junio C Hamano41ac4142008-02-01 01:50:53 -0800445 test_fixed=$(($test_fixed+1))
Thomas Rast633fe502013-10-19 23:06:08 +0200446 say_color error "ok $test_count - $@ # TODO known breakage vanished"
Junio C Hamano41ac4142008-02-01 01:50:53 -0800447}
448
449test_known_broken_failure_ () {
Junio C Hamano41ac4142008-02-01 01:50:53 -0800450 test_broken=$(($test_broken+1))
Thomas Rast633fe502013-10-19 23:06:08 +0200451 say_color warn "not ok $test_count - $@ # TODO known breakage"
Junio C Hamano41ac4142008-02-01 01:50:53 -0800452}
Junio C Hamano886856a2005-05-14 00:24:27 -0700453
454test_debug () {
Junio C Hamano8e832eb2005-08-10 22:53:27 -0700455 test "$debug" = "" || eval "$1"
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700456}
457
Thomas Raste6a6ddc2013-06-18 14:25:58 +0200458match_pattern_list () {
459 arg="$1"
460 shift
461 test -z "$*" && return 1
462 for pattern_
463 do
464 case "$arg" in
465 $pattern_)
466 return 0
467 esac
468 done
469 return 1
470}
471
Ilya Bobyr0445e6f2014-04-30 02:50:44 -0700472match_test_selector_list () {
473 title="$1"
474 shift
475 arg="$1"
476 shift
477 test -z "$1" && return 0
478
479 # Both commas and whitespace are accepted as separators.
480 OLDIFS=$IFS
481 IFS=' ,'
482 set -- $1
483 IFS=$OLDIFS
484
485 # If the first selector is negative we include by default.
486 include=
487 case "$1" in
488 !*) include=t ;;
489 esac
490
491 for selector
492 do
493 orig_selector=$selector
494
495 positive=t
496 case "$selector" in
497 !*)
498 positive=
499 selector=${selector##?}
500 ;;
501 esac
502
503 test -z "$selector" && continue
504
505 case "$selector" in
506 *-*)
507 if expr "z${selector%%-*}" : "z[0-9]*[^0-9]" >/dev/null
508 then
509 echo "error: $title: invalid non-numeric in range" \
510 "start: '$orig_selector'" >&2
511 exit 1
512 fi
513 if expr "z${selector#*-}" : "z[0-9]*[^0-9]" >/dev/null
514 then
515 echo "error: $title: invalid non-numeric in range" \
516 "end: '$orig_selector'" >&2
517 exit 1
518 fi
519 ;;
520 *)
521 if expr "z$selector" : "z[0-9]*[^0-9]" >/dev/null
522 then
523 echo "error: $title: invalid non-numeric in test" \
524 "selector: '$orig_selector'" >&2
525 exit 1
526 fi
527 esac
528
529 # Short cut for "obvious" cases
530 test -z "$include" && test -z "$positive" && continue
531 test -n "$include" && test -n "$positive" && continue
532
533 case "$selector" in
534 -*)
535 if test $arg -le ${selector#-}
536 then
537 include=$positive
538 fi
539 ;;
540 *-)
541 if test $arg -ge ${selector%-}
542 then
543 include=$positive
544 fi
545 ;;
546 *-*)
547 if test ${selector%%-*} -le $arg \
548 && test $arg -le ${selector#*-}
549 then
550 include=$positive
551 fi
552 ;;
553 *)
554 if test $arg -eq $selector
555 then
556 include=$positive
557 fi
558 ;;
559 esac
560 done
561
562 test -n "$include"
563}
564
Thomas Rastff09af32013-06-23 20:12:56 +0200565maybe_teardown_verbose () {
566 test -z "$verbose_only" && return
567 exec 4>/dev/null 3>/dev/null
568 verbose=
569}
570
571last_verbose=t
572maybe_setup_verbose () {
573 test -z "$verbose_only" && return
Thomas Rast26a07302013-10-19 23:06:07 +0200574 if match_pattern_list $test_count $verbose_only
Thomas Rastff09af32013-06-23 20:12:56 +0200575 then
576 exec 4>&2 3>&1
577 # Emit a delimiting blank line when going from
578 # non-verbose to verbose. Within verbose mode the
579 # delimiter is printed by test_expect_*. The choice
580 # of the initial $last_verbose is such that before
581 # test 1, we do not print it.
582 test -z "$last_verbose" && echo >&3 ""
583 verbose=t
584 else
585 exec 4>/dev/null 3>/dev/null
586 verbose=
587 fi
588 last_verbose=$verbose
589}
590
Thomas Rast5dfc3682013-06-23 20:12:57 +0200591maybe_teardown_valgrind () {
592 test -z "$GIT_VALGRIND" && return
593 GIT_VALGRIND_ENABLED=
594}
595
596maybe_setup_valgrind () {
597 test -z "$GIT_VALGRIND" && return
Thomas Rast26a07302013-10-19 23:06:07 +0200598 if test -z "$valgrind_only"
Thomas Rast5dfc3682013-06-23 20:12:57 +0200599 then
600 GIT_VALGRIND_ENABLED=t
601 return
602 fi
603 GIT_VALGRIND_ENABLED=
604 if match_pattern_list $test_count $valgrind_only
605 then
606 GIT_VALGRIND_ENABLED=t
607 fi
608}
609
Jeff King9b5fe782015-08-06 01:33:57 -0400610want_trace () {
Jeff Kingf5ba2de2017-12-08 05:47:17 -0500611 test "$trace" = t && {
612 test "$verbose" = t || test "$verbose_log" = t
613 }
Jeff King9b5fe782015-08-06 01:33:57 -0400614}
615
Jeff Kinga136f6d2014-10-10 02:47:27 -0400616# This is a separate function because some tests use
617# "return" to end a test_expect_success block early
618# (and we want to make sure we run any cleanup like
619# "set +x").
620test_eval_inner_ () {
621 # Do not add anything extra (including LF) after '$*'
622 eval "
Jeff King9b5fe782015-08-06 01:33:57 -0400623 want_trace && set -x
Jeff Kinga136f6d2014-10-10 02:47:27 -0400624 $*"
625}
626
Jonathan Niedera7c58f22011-08-08 03:17:09 +0200627test_eval_ () {
Jeff King90c8a1d2017-12-08 05:47:08 -0500628 # If "-x" tracing is in effect, then we want to avoid polluting stderr
629 # with non-test commands. But once in "set -x" mode, we cannot prevent
Jeff Kinga136f6d2014-10-10 02:47:27 -0400630 # the shell from printing the "set +x" to turn it off (nor the saving
631 # of $? before that). But we can make sure that the output goes to
632 # /dev/null.
633 #
Jeff King90c8a1d2017-12-08 05:47:08 -0500634 # There are a few subtleties here:
635 #
636 # - we have to redirect descriptor 4 in addition to 2, to cover
637 # BASH_XTRACEFD
638 #
639 # - the actual eval has to come before the redirection block (since
640 # it needs to see descriptor 4 to set up its stderr)
641 #
642 # - likewise, any error message we print must be outside the block to
643 # access descriptor 4
644 #
645 # - checking $? has to come immediately after the eval, but it must
646 # be _inside_ the block to avoid polluting the "set -x" output
647 #
648
649 test_eval_inner_ "$@" </dev/null >&3 2>&4
Jeff Kinga136f6d2014-10-10 02:47:27 -0400650 {
Jeff Kinga136f6d2014-10-10 02:47:27 -0400651 test_eval_ret_=$?
Jeff King9b5fe782015-08-06 01:33:57 -0400652 if want_trace
Jeff Kinga136f6d2014-10-10 02:47:27 -0400653 then
654 set +x
Jeff Kinga136f6d2014-10-10 02:47:27 -0400655 fi
Jeff King90c8a1d2017-12-08 05:47:08 -0500656 } 2>/dev/null 4>&2
657
658 if test "$test_eval_ret_" != 0 && want_trace
659 then
660 say_color error >&4 "error: last command exited with \$?=$test_eval_ret_"
661 fi
Jeff Kinga136f6d2014-10-10 02:47:27 -0400662 return $test_eval_ret_
Jonathan Niedera7c58f22011-08-08 03:17:09 +0200663}
664
Pavel Roskin4d9d62f2005-08-10 23:56:21 -0400665test_run_ () {
Jonathan Niederb6b0afd2010-05-06 03:41:10 -0500666 test_cleanup=:
Junio C Hamanob5867442011-06-27 11:02:22 -0700667 expecting_failure=$2
Jeff Kingbb79af92015-03-20 06:05:48 -0400668
Jeff King92b269f2015-04-22 16:09:57 -0400669 if test "${GIT_TEST_CHAIN_LINT:-1}" != 0; then
Jeff King2a01ef82015-08-06 01:31:47 -0400670 # turn off tracing for this test-eval, as it simply creates
671 # confusing noise in the "-x" output
672 trace_tmp=$trace
673 trace=
Jeff Kingbb79af92015-03-20 06:05:48 -0400674 # 117 is magic because it is unlikely to match the exit
675 # code of other programs
Junio C Hamano99a64e42017-03-22 22:43:18 -0700676 if test "OK-117" != "$(test_eval_ "(exit 117) && $1${LF}${LF}echo OK-\$?" 3>&1)"
677 then
678 error "bug in the test script: broken &&-chain or run-away HERE-DOC: $1"
Jeff Kingbb79af92015-03-20 06:05:48 -0400679 fi
Jeff King2a01ef82015-08-06 01:31:47 -0400680 trace=$trace_tmp
Jeff Kingbb79af92015-03-20 06:05:48 -0400681 fi
682
Thomas Rasta57397b2013-06-17 11:18:46 +0200683 setup_malloc_check
Jonathan Niedera7c58f22011-08-08 03:17:09 +0200684 test_eval_ "$1"
Jonathan Niederb6b0afd2010-05-06 03:41:10 -0500685 eval_ret=$?
Thomas Rasta57397b2013-06-17 11:18:46 +0200686 teardown_malloc_check
Junio C Hamanob5867442011-06-27 11:02:22 -0700687
Jeff Kinga136f6d2014-10-10 02:47:27 -0400688 if test -z "$immediate" || test $eval_ret = 0 ||
689 test -n "$expecting_failure" && test "$test_cleanup" != ":"
Junio C Hamanob5867442011-06-27 11:02:22 -0700690 then
Junio C Hamano1b3185f2012-09-14 20:38:24 -0700691 setup_malloc_check
Jonathan Niedera7c58f22011-08-08 03:17:09 +0200692 test_eval_ "$test_cleanup"
Junio C Hamano1b3185f2012-09-14 20:38:24 -0700693 teardown_malloc_check
Junio C Hamanob5867442011-06-27 11:02:22 -0700694 fi
Ramsay Jones1c0cc752012-09-01 19:11:49 +0100695 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
696 then
Ævar Arnfjörð Bjarmason57e15382010-06-24 17:44:47 +0000697 echo ""
698 fi
Jonathan Niederaa0bcf92011-08-08 03:15:34 +0200699 return "$eval_ret"
Pavel Roskin4d9d62f2005-08-10 23:56:21 -0400700}
701
Thomas Rastae753422013-06-18 14:25:59 +0200702test_start_ () {
Johannes Sixt8586f982009-02-05 21:20:56 +0100703 test_count=$(($test_count+1))
Thomas Rastff09af32013-06-23 20:12:56 +0200704 maybe_setup_verbose
Thomas Rast5dfc3682013-06-23 20:12:57 +0200705 maybe_setup_valgrind
Thomas Rastae753422013-06-18 14:25:59 +0200706}
707
708test_finish_ () {
709 echo >&3 ""
Thomas Rast5dfc3682013-06-23 20:12:57 +0200710 maybe_teardown_valgrind
Thomas Rastff09af32013-06-23 20:12:56 +0200711 maybe_teardown_verbose
Thomas Rastae753422013-06-18 14:25:59 +0200712}
713
714test_skip () {
Junio C Hamano04ece592006-12-28 17:58:00 -0800715 to_skip=
Ilya Bobyref2ac682014-04-30 02:50:43 -0700716 skipped_reason=
Thomas Raste6a6ddc2013-06-18 14:25:58 +0200717 if match_pattern_list $this_test.$test_count $GIT_SKIP_TESTS
718 then
719 to_skip=t
Ilya Bobyref2ac682014-04-30 02:50:43 -0700720 skipped_reason="GIT_SKIP_TESTS"
Thomas Raste6a6ddc2013-06-18 14:25:58 +0200721 fi
Jonathan Nieder05236a52010-10-17 02:36:58 +0800722 if test -z "$to_skip" && test -n "$test_prereq" &&
723 ! test_have_prereq "$test_prereq"
Johannes Sixta7bb3942009-03-01 21:04:46 +0100724 then
725 to_skip=t
Ilya Bobyref2ac682014-04-30 02:50:43 -0700726
Jonathan Nieder07431fc2010-08-24 02:34:10 -0500727 of_prereq=
Jonathan Nieder05236a52010-10-17 02:36:58 +0800728 if test "$missing_prereq" != "$test_prereq"
Jonathan Nieder07431fc2010-08-24 02:34:10 -0500729 then
Jonathan Nieder05236a52010-10-17 02:36:58 +0800730 of_prereq=" of $test_prereq"
Jonathan Nieder07431fc2010-08-24 02:34:10 -0500731 fi
Ilya Bobyref2ac682014-04-30 02:50:43 -0700732 skipped_reason="missing $missing_prereq${of_prereq}"
733 fi
Ilya Bobyr0445e6f2014-04-30 02:50:44 -0700734 if test -z "$to_skip" && test -n "$run_list" &&
735 ! match_test_selector_list '--run' $test_count "$run_list"
736 then
737 to_skip=t
738 skipped_reason="--run"
739 fi
Jonathan Nieder07431fc2010-08-24 02:34:10 -0500740
Ilya Bobyref2ac682014-04-30 02:50:43 -0700741 case "$to_skip" in
742 t)
Thomas Rast633fe502013-10-19 23:06:08 +0200743 say_color skip >&3 "skipping test: $@"
Ilya Bobyref2ac682014-04-30 02:50:43 -0700744 say_color skip "ok $test_count # skip $1 ($skipped_reason)"
Junio C Hamano04ece592006-12-28 17:58:00 -0800745 : true
746 ;;
747 *)
748 false
749 ;;
750 esac
751}
752
Thomas Rast342e9ef2012-02-17 11:25:09 +0100753# stub; perf-lib overrides it
754test_at_end_hook_ () {
755 :
756}
757
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700758test_done () {
Clemens Buchacher6e7b5aa2009-06-01 14:14:41 +0200759 GIT_EXIT_OK=t
Sverre Rabbelier2d84e9f2008-06-08 16:04:33 +0200760
Ramsay Jones1c0cc752012-09-01 19:11:49 +0100761 if test -z "$HARNESS_ACTIVE"
762 then
Thomas Rast342e9ef2012-02-17 11:25:09 +0100763 test_results_dir="$TEST_OUTPUT_DIRECTORY/test-results"
Ævar Arnfjörð Bjarmason8ef1abe2010-08-11 19:37:31 +0000764 mkdir -p "$test_results_dir"
Felipe Contrerasdd784782012-11-04 03:13:33 +0100765 base=${0##*/}
Jeff King5c885c12016-08-30 04:43:57 -0400766 test_results_path="$test_results_dir/${base%.sh}.counts"
Ævar Arnfjörð Bjarmason8ef1abe2010-08-11 19:37:31 +0000767
Jeff King5c885c12016-08-30 04:43:57 -0400768 cat >"$test_results_path" <<-EOF
Mathias Lafeldtc54e6be2011-04-29 14:30:30 +0200769 total $test_count
770 success $test_success
771 fixed $test_fixed
772 broken $test_broken
773 failed $test_failure
774
775 EOF
Ævar Arnfjörð Bjarmason8ef1abe2010-08-11 19:37:31 +0000776 fi
Junio C Hamano41ac4142008-02-01 01:50:53 -0800777
778 if test "$test_fixed" != 0
779 then
Thomas Rast633fe502013-10-19 23:06:08 +0200780 say_color error "# $test_fixed known breakage(s) vanished; please update test(s)"
Junio C Hamano41ac4142008-02-01 01:50:53 -0800781 fi
782 if test "$test_broken" != 0
783 then
Thomas Rast633fe502013-10-19 23:06:08 +0200784 say_color warn "# still have $test_broken known breakage(s)"
Adam Spiersb73d9a22012-12-16 18:28:15 +0000785 fi
786 if test "$test_broken" != 0 || test "$test_fixed" != 0
787 then
788 test_remaining=$(( $test_count - $test_broken - $test_fixed ))
789 msg="remaining $test_remaining test(s)"
Junio C Hamano11d54b82008-02-03 00:23:02 -0800790 else
Adam Spiersb73d9a22012-12-16 18:28:15 +0000791 test_remaining=$test_count
Junio C Hamano11d54b82008-02-03 00:23:02 -0800792 msg="$test_count test(s)"
Junio C Hamano41ac4142008-02-01 01:50:53 -0800793 fi
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700794 case "$test_failure" in
Junio C Hamano10b94e22005-12-09 17:32:18 -0800795 0)
Ramsay Jones1c0cc752012-09-01 19:11:49 +0100796 if test $test_external_has_tap -eq 0
797 then
Adam Spiersb73d9a22012-12-16 18:28:15 +0000798 if test $test_remaining -gt 0
Ramsay Jonesd87bd7c2012-09-01 19:26:21 +0100799 then
Thomas Rast633fe502013-10-19 23:06:08 +0200800 say_color pass "# passed all $msg"
Ramsay Jonesd87bd7c2012-09-01 19:26:21 +0100801 fi
Junio C Hamanoc7018be2017-05-18 11:52:20 +0900802
803 # Maybe print SKIP message
804 test -z "$skip_all" || skip_all="# SKIP $skip_all"
805 case "$test_count" in
806 0)
807 say "1..$test_count${skip_all:+ $skip_all}"
808 ;;
809 *)
810 test -z "$skip_all" ||
811 say_color warn "$skip_all"
812 say "1..$test_count"
813 ;;
814 esac
Ævar Arnfjörð Bjarmasond998bd42010-06-24 17:44:46 +0000815 fi
Johannes Schindelinabc5d372008-08-08 13:08:37 +0200816
Junio C Hamano06478da2017-04-23 17:15:09 -0700817 if test -z "$debug"
Junio C Hamano4d0912a2017-04-24 23:39:47 -0700818 then
Junio C Hamano06478da2017-04-23 17:15:09 -0700819 test -d "$TRASH_DIRECTORY" ||
Junio C Hamano4d0912a2017-04-24 23:39:47 -0700820 error "Tests passed but trash directory already removed before test cleanup; aborting"
Johannes Schindelinabc5d372008-08-08 13:08:37 +0200821
Junio C Hamano06478da2017-04-23 17:15:09 -0700822 cd "$TRASH_DIRECTORY/.." &&
823 rm -fr "$TRASH_DIRECTORY" ||
Junio C Hamano4d0912a2017-04-24 23:39:47 -0700824 error "Tests passed but test cleanup failed; aborting"
Junio C Hamano4d0912a2017-04-24 23:39:47 -0700825 fi
Thomas Rast342e9ef2012-02-17 11:25:09 +0100826 test_at_end_hook_
827
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700828 exit 0 ;;
829
830 *)
Ramsay Jones1c0cc752012-09-01 19:11:49 +0100831 if test $test_external_has_tap -eq 0
832 then
Thomas Rast633fe502013-10-19 23:06:08 +0200833 say_color error "# failed $test_failure among $msg"
834 say "1..$test_count"
Ævar Arnfjörð Bjarmasond998bd42010-06-24 17:44:46 +0000835 fi
Ævar Arnfjörð Bjarmason5099b992010-06-24 21:52:12 +0000836
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700837 exit 1 ;;
838
839 esac
840}
841
Matthew Ogilviee4597aa2009-12-02 22:14:06 -0700842if test -n "$valgrind"
Johannes Schindelin4e1be632009-02-04 00:25:59 +0100843then
Johannes Schindelin4e1be632009-02-04 00:25:59 +0100844 make_symlink () {
845 test -h "$2" &&
846 test "$1" = "$(readlink "$2")" || {
847 # be super paranoid
848 if mkdir "$2".lock
849 then
850 rm -f "$2" &&
851 ln -s "$1" "$2" &&
852 rm -r "$2".lock
853 else
854 while test -d "$2".lock
855 do
856 say "Waiting for lock on $2."
857 sleep 1
858 done
859 fi
860 }
861 }
862
863 make_valgrind_symlink () {
Jeff King36bfb0e2011-06-17 16:36:32 -0400864 # handle only executables, unless they are shell libraries that
Jonathan Nieder11d62142013-11-25 13:03:52 -0800865 # need to be in the exec-path.
Jeff King36bfb0e2011-06-17 16:36:32 -0400866 test -x "$1" ||
Jonathan Nieder11d62142013-11-25 13:03:52 -0800867 test "# " = "$(head -c 2 <"$1")" ||
Jeff King36bfb0e2011-06-17 16:36:32 -0400868 return;
Johannes Schindelin4e1be632009-02-04 00:25:59 +0100869
870 base=$(basename "$1")
René Scharfe28fab7b2016-10-28 00:14:00 +0200871 case "$base" in
872 test-*)
873 symlink_target="$GIT_BUILD_DIR/t/helper/$base"
874 ;;
875 *)
876 symlink_target="$GIT_BUILD_DIR/$base"
877 ;;
878 esac
Johannes Schindelin4e1be632009-02-04 00:25:59 +0100879 # do not override scripts
880 if test -x "$symlink_target" &&
881 test ! -d "$symlink_target" &&
882 test "#!" != "$(head -c 2 < "$symlink_target")"
883 then
884 symlink_target=../valgrind.sh
885 fi
Johannes Schindelinefd92ff2009-02-04 00:26:08 +0100886 case "$base" in
887 *.sh|*.perl)
888 symlink_target=../unprocessed-script
889 esac
Johannes Schindelin4e1be632009-02-04 00:25:59 +0100890 # create the link, or replace it if it is out of date
891 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
892 }
893
Thomas Rast26a07302013-10-19 23:06:07 +0200894 # override all git executables in TEST_DIRECTORY/..
895 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
896 mkdir -p "$GIT_VALGRIND"/bin
Johannes Schindelin503e2242016-07-11 13:45:08 +0200897 for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/t/helper/test-*
Thomas Rast26a07302013-10-19 23:06:07 +0200898 do
899 make_valgrind_symlink $file
900 done
901 # special-case the mergetools loadables
902 make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
903 OLDIFS=$IFS
904 IFS=:
905 for path in $PATH
906 do
907 ls "$path"/git-* 2> /dev/null |
908 while read file
Johannes Schindelinefd92ff2009-02-04 00:26:08 +0100909 do
Thomas Rast26a07302013-10-19 23:06:07 +0200910 make_valgrind_symlink "$file"
Johannes Schindelinefd92ff2009-02-04 00:26:08 +0100911 done
Thomas Rast26a07302013-10-19 23:06:07 +0200912 done
913 IFS=$OLDIFS
Johannes Schindelin4e1be632009-02-04 00:25:59 +0100914 PATH=$GIT_VALGRIND/bin:$PATH
915 GIT_EXEC_PATH=$GIT_VALGRIND/bin
916 export GIT_VALGRIND
Thomas Rast952af352013-03-31 10:00:16 +0200917 GIT_VALGRIND_MODE="$valgrind"
918 export GIT_VALGRIND_MODE
Thomas Rast5dfc3682013-06-23 20:12:57 +0200919 GIT_VALGRIND_ENABLED=t
Thomas Rast26a07302013-10-19 23:06:07 +0200920 test -n "$valgrind_only" && GIT_VALGRIND_ENABLED=
Thomas Rast5dfc3682013-06-23 20:12:57 +0200921 export GIT_VALGRIND_ENABLED
Ramsay Jones1c0cc752012-09-01 19:11:49 +0100922elif test -n "$GIT_TEST_INSTALLED"
923then
Matthew Ogilviee4597aa2009-12-02 22:14:06 -0700924 GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) ||
925 error "Cannot run git from $GIT_TEST_INSTALLED."
Ævar Arnfjörð Bjarmason6cec5c62010-08-19 16:08:10 +0000926 PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
Matthew Ogilviee4597aa2009-12-02 22:14:06 -0700927 GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
928else # normal case, use ../bin-wrappers only unless $with_dashes:
Ævar Arnfjörð Bjarmason6cec5c62010-08-19 16:08:10 +0000929 git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
Ramsay Jones1c0cc752012-09-01 19:11:49 +0100930 if ! test -x "$git_bin_dir/git"
931 then
932 if test -z "$with_dashes"
933 then
Matthew Ogilviee4597aa2009-12-02 22:14:06 -0700934 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
935 fi
936 with_dashes=t
937 fi
938 PATH="$git_bin_dir:$PATH"
Ævar Arnfjörð Bjarmason6cec5c62010-08-19 16:08:10 +0000939 GIT_EXEC_PATH=$GIT_BUILD_DIR
Ramsay Jones1c0cc752012-09-01 19:11:49 +0100940 if test -n "$with_dashes"
941 then
Ævar Arnfjörð Bjarmason6cec5c62010-08-19 16:08:10 +0000942 PATH="$GIT_BUILD_DIR:$PATH"
Matthew Ogilviee4597aa2009-12-02 22:14:06 -0700943 fi
Johannes Schindelin4e1be632009-02-04 00:25:59 +0100944fi
Ævar Arnfjörð Bjarmason6cec5c62010-08-19 16:08:10 +0000945GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
Jeff King8bfa6bd2008-02-06 05:11:53 -0500946GIT_CONFIG_NOSYSTEM=1
Jonathan Nieder3c995be2011-03-15 04:05:10 -0500947GIT_ATTR_NOSYSTEM=1
Jonathan Nieder8f323c02011-03-15 04:04:49 -0500948export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
Junio C Hamano49ccb082005-12-07 21:52:28 -0800949
Junio C Hamano5e87eae2010-06-11 09:40:25 -0700950if test -z "$GIT_TEST_CMP"
951then
952 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
953 then
954 GIT_TEST_CMP="$DIFF -c"
955 else
956 GIT_TEST_CMP="$DIFF -u"
957 fi
958fi
959
Ævar Arnfjörð Bjarmason20d2a302017-12-10 21:13:33 +0000960GITPERLLIB="$GIT_BUILD_DIR"/perl/build/lib
Petr Baudis6fcca932006-07-03 23:16:32 +0200961export GITPERLLIB
Ævar Arnfjörð Bjarmason6cec5c62010-08-19 16:08:10 +0000962test -d "$GIT_BUILD_DIR"/templates/blt || {
Junio C Hamanoeea42062005-12-10 20:55:32 -0800963 error "You haven't built things yet, have you?"
964}
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700965
Nguyễn Thái Ngọc Duy0e496492018-03-24 08:44:31 +0100966if ! test -x "$GIT_BUILD_DIR"/t/helper/test-tool
Ramsay Jones1c0cc752012-09-01 19:11:49 +0100967then
Nguyễn Thái Ngọc Duy0e496492018-03-24 08:44:31 +0100968 echo >&2 'You need to build test-tool:'
969 echo >&2 'Run "make t/helper/test-tool" in the source (toplevel) directory'
Eric Wong56cf9802007-02-24 16:59:52 -0800970 exit 1
971fi
972
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700973# Test repository
Jeff King002d4ce2013-04-14 15:38:21 -0400974TRASH_DIRECTORY="trash directory.$(basename "$0" .sh)"
975test -n "$root" && TRASH_DIRECTORY="$root/$TRASH_DIRECTORY"
976case "$TRASH_DIRECTORY" in
977/*) ;; # absolute path is good
978 *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;;
Jeff Kingf423ef52009-08-09 04:39:45 -0400979esac
John Keeping38b074d2013-04-14 17:34:56 +0100980rm -fr "$TRASH_DIRECTORY" || {
Clemens Buchacher6e7b5aa2009-06-01 14:14:41 +0200981 GIT_EXIT_OK=t
Junio C Hamano8d14ac92008-03-18 21:58:01 -0700982 echo >&5 "FATAL: Cannot prepare test area"
983 exit 1
984}
985
Alex Riesen90cff962011-03-26 19:46:34 +0100986HOME="$TRASH_DIRECTORY"
Junio C Hamano0ea47f92014-09-15 14:59:00 -0700987GNUPGHOME="$HOME/gnupg-home-not-used"
988export HOME GNUPGHOME
Alex Riesen90cff962011-03-26 19:46:34 +0100989
Ramsay Jones1c0cc752012-09-01 19:11:49 +0100990if test -z "$TEST_NO_CREATE_REPO"
991then
John Keeping38b074d2013-04-14 17:34:56 +0100992 test_create_repo "$TRASH_DIRECTORY"
Thomas Rast342e9ef2012-02-17 11:25:09 +0100993else
John Keeping38b074d2013-04-14 17:34:56 +0100994 mkdir -p "$TRASH_DIRECTORY"
Thomas Rast342e9ef2012-02-17 11:25:09 +0100995fi
Lea Wiemann1bd9c642008-05-31 23:11:21 +0200996# Use -P to resolve symlinks in our working directory so that the cwd
997# in subprocesses like git equals our $PWD (for pathname comparisons).
John Keeping38b074d2013-04-14 17:34:56 +0100998cd -P "$TRASH_DIRECTORY" || exit 1
Junio C Hamano04ece592006-12-28 17:58:00 -0800999
Johannes Sixtd5d9de12009-02-05 20:59:27 +01001000this_test=${0##*/}
1001this_test=${this_test%%-*}
Thomas Raste6a6ddc2013-06-18 14:25:58 +02001002if match_pattern_list "$this_test" $GIT_SKIP_TESTS
1003then
1004 say_color info >&3 "skipping test $this_test altogether"
1005 skip_all="skip all tests in $this_test"
1006 test_done
1007fi
Johannes Sixtf17e9fb2009-03-11 21:17:26 +01001008
Brandon Casey86487322009-08-28 17:32:41 -05001009# Provide an implementation of the 'yes' utility
1010yes () {
1011 if test $# = 0
1012 then
1013 y=y
1014 else
1015 y="$*"
1016 fi
1017
Johannes Schindelin6129c932016-02-02 19:15:53 +01001018 i=0
1019 while test $i -lt 99
Brandon Casey86487322009-08-28 17:32:41 -05001020 do
Johannes Schindelin6129c932016-02-02 19:15:53 +01001021 echo "$y"
1022 i=$(($i+1))
Brandon Casey86487322009-08-28 17:32:41 -05001023 done
1024}
1025
Johannes Sixtf17e9fb2009-03-11 21:17:26 +01001026# Fix some commands on Windows
Johannes Schindelind98b2c52016-07-21 18:02:54 +02001027uname_s=$(uname -s)
1028case $uname_s in
Johannes Sixtf17e9fb2009-03-11 21:17:26 +01001029*MINGW*)
1030 # Windows has its own (incompatible) sort and find
1031 sort () {
1032 /usr/bin/sort "$@"
1033 }
1034 find () {
1035 /usr/bin/find "$@"
1036 }
Johannes Sixt41141562009-03-13 23:35:24 +01001037 # git sees Windows-style pwd
1038 pwd () {
1039 builtin pwd -W
1040 }
Johannes Sixtee9fb682009-03-13 22:55:27 +01001041 # no POSIX permissions
Johannes Sixt6fd11062009-03-13 23:00:15 +01001042 # backslashes in pathspec are converted to '/'
Johannes Sixtfb9a2be2009-03-25 13:21:15 +01001043 # exec does not inherit the PID
Pat Thoytsa94114a2010-09-12 10:37:24 +01001044 test_set_prereq MINGW
Brice Lambson5f4e02e2014-08-30 23:39:07 +02001045 test_set_prereq NATIVE_CRLF
Ramsay Jonesa31d0662010-12-14 18:32:12 +00001046 test_set_prereq SED_STRIPS_CR
Mark Levedahl97669ee2013-07-18 17:44:57 -04001047 test_set_prereq GREP_STRIPS_CR
Johannes Sixt4d715ac2013-10-26 21:17:15 +02001048 GIT_TEST_CMP=mingw_test_cmp
Ramsay Jonesa31d0662010-12-14 18:32:12 +00001049 ;;
1050*CYGWIN*)
1051 test_set_prereq POSIXPERM
Ramsay Jonesa31d0662010-12-14 18:32:12 +00001052 test_set_prereq EXECKEEPSPID
Pete Wyckoffcfa96492013-01-26 22:11:11 -05001053 test_set_prereq CYGWIN
Ramsay Jonesa31d0662010-12-14 18:32:12 +00001054 test_set_prereq SED_STRIPS_CR
Mark Levedahl97669ee2013-07-18 17:44:57 -04001055 test_set_prereq GREP_STRIPS_CR
Johannes Sixtee9fb682009-03-13 22:55:27 +01001056 ;;
1057*)
1058 test_set_prereq POSIXPERM
Johannes Sixt6fd11062009-03-13 23:00:15 +01001059 test_set_prereq BSLASHPSPEC
Johannes Sixtfb9a2be2009-03-25 13:21:15 +01001060 test_set_prereq EXECKEEPSPID
Johannes Sixtf17e9fb2009-03-11 21:17:26 +01001061 ;;
1062esac
Johannes Sixt704a3142009-03-04 22:38:24 +01001063
Zbigniew Jędrzejewski-Szmekb0826872012-04-27 11:25:25 +02001064( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
Jeff King1b19ccd2009-04-03 15:33:59 -04001065test -z "$NO_PERL" && test_set_prereq PERL
Ævar Arnfjörð Bjarmason68c7d272017-05-25 19:45:31 +00001066test -z "$NO_PTHREADS" && test_set_prereq PTHREADS
Johan Herlandd4e1b472009-11-18 02:42:31 +01001067test -z "$NO_PYTHON" && test_set_prereq PYTHON
Ævar Arnfjörð Bjarmason94da9192017-06-01 18:20:56 +00001068test -n "$USE_LIBPCRE1$USE_LIBPCRE2" && test_set_prereq PCRE
Ævar Arnfjörð Bjarmasonce9a2572017-11-23 14:16:57 +00001069test -n "$USE_LIBPCRE1" && test_set_prereq LIBPCRE1
1070test -n "$USE_LIBPCRE2" && test_set_prereq LIBPCRE2
Ævar Arnfjörð Bjarmason5e9637c2011-11-18 00:14:42 +01001071test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
Jeff King1b19ccd2009-04-03 15:33:59 -04001072
Ævar Arnfjörð Bjarmasonbb946bb2011-02-22 23:41:21 +00001073# Can we rely on git's output in the C locale?
Jonathan Nieder30955222011-02-22 23:41:22 +00001074if test -n "$GETTEXT_POISON"
1075then
1076 GIT_GETTEXT_POISON=YesPlease
1077 export GIT_GETTEXT_POISON
Ævar Arnfjörð Bjarmason5e9637c2011-11-18 00:14:42 +01001078 test_set_prereq GETTEXT_POISON
Jonathan Nieder30955222011-02-22 23:41:22 +00001079else
1080 test_set_prereq C_LOCALE_OUTPUT
1081fi
Ævar Arnfjörð Bjarmasonbb946bb2011-02-22 23:41:21 +00001082
Adam Spiers20073272013-04-11 03:07:04 +01001083test_lazy_prereq PIPE '
1084 # test whether the filesystem supports FIFOs
Ramsay Jones7b7bea22017-09-17 23:56:00 +01001085 test_have_prereq !MINGW,!CYGWIN &&
1086 rm -f testfifo && mkfifo testfifo
Adam Spiers20073272013-04-11 03:07:04 +01001087'
1088
Junio C Hamano04083f22012-07-26 15:50:45 -07001089test_lazy_prereq SYMLINKS '
1090 # test whether the filesystem supports symbolic links
1091 ln -s x y && test -h y
1092'
Ævar Arnfjörð Bjarmasonc91cfd12010-08-06 22:09:09 +00001093
Jonathan Niederb018c732013-11-25 13:02:16 -08001094test_lazy_prereq FILEMODE '
1095 test "$(git config --bool core.filemode)" = true
1096'
1097
Michael J Gruberac39aa62012-07-26 15:39:53 +02001098test_lazy_prereq CASE_INSENSITIVE_FS '
1099 echo good >CamelCase &&
1100 echo bad >camelcase &&
1101 test "$(cat CamelCase)" != good
1102'
1103
Michael J Gruber5b0b5dd2012-07-26 15:39:56 +02001104test_lazy_prereq UTF8_NFD_TO_NFC '
1105 # check whether FS converts nfd unicode to nfc
1106 auml=$(printf "\303\244")
1107 aumlcdiar=$(printf "\141\314\210")
1108 >"$auml" &&
1109 case "$(echo *)" in
1110 "$aumlcdiar")
1111 true ;;
1112 *)
1113 false ;;
1114 esac
1115'
1116
Jeff King09feffb2012-11-14 16:33:40 -08001117test_lazy_prereq AUTOIDENT '
1118 sane_unset GIT_AUTHOR_NAME &&
1119 sane_unset GIT_AUTHOR_EMAIL &&
1120 git var GIT_AUTHOR_IDENT
1121'
1122
Junio C Hamano6219bb22014-06-09 12:23:30 -07001123test_lazy_prereq EXPENSIVE '
1124 test -n "$GIT_TEST_LONG"
1125'
1126
Ævar Arnfjörð Bjarmason5b1fe6e2018-01-30 21:21:23 +00001127test_lazy_prereq EXPENSIVE_ON_WINDOWS '
1128 test_have_prereq EXPENSIVE || test_have_prereq !MINGW,!CYGWIN
1129'
1130
Junio C Hamanoe1ecd9e2014-06-09 13:54:25 -07001131test_lazy_prereq USR_BIN_TIME '
1132 test -x /usr/bin/time
1133'
1134
Jeff King1767c512015-01-16 04:16:49 -05001135test_lazy_prereq NOT_ROOT '
1136 uid=$(id -u) &&
1137 test "$uid" != 0
1138'
1139
Jonathan Tan63b747c2016-09-09 10:36:28 -07001140test_lazy_prereq JGIT '
1141 type jgit
1142'
1143
Junio C Hamano719c3da2016-01-19 14:09:37 -08001144# SANITY is about "can you correctly predict what the filesystem would
1145# do by only looking at the permission bits of the files and
1146# directories?" A typical example of !SANITY is running the test
1147# suite as root, where a test may expect "chmod -r file && cat file"
1148# to fail because file is supposed to be unreadable after a successful
1149# chmod. In an environment (i.e. combination of what filesystem is
1150# being used and who is running the tests) that lacks SANITY, you may
1151# be able to delete or create a file when the containing directory
1152# doesn't have write permissions, or access a file even if the
1153# containing directory doesn't have read or execute permissions.
1154
Torsten Bögershausenf400e512015-01-27 16:39:01 +01001155test_lazy_prereq SANITY '
1156 mkdir SANETESTD.1 SANETESTD.2 &&
1157
1158 chmod +w SANETESTD.1 SANETESTD.2 &&
1159 >SANETESTD.1/x 2>SANETESTD.2/x &&
1160 chmod -w SANETESTD.1 &&
Junio C Hamano719c3da2016-01-19 14:09:37 -08001161 chmod -r SANETESTD.1/x &&
Torsten Bögershausenf400e512015-01-27 16:39:01 +01001162 chmod -rx SANETESTD.2 ||
1163 error "bug in test sript: cannot prepare SANETESTD"
1164
Junio C Hamano719c3da2016-01-19 14:09:37 -08001165 ! test -r SANETESTD.1/x &&
Torsten Bögershausenf400e512015-01-27 16:39:01 +01001166 ! rm SANETESTD.1/x && ! test -f SANETESTD.2/x
1167 status=$?
1168
1169 chmod +rwx SANETESTD.1 SANETESTD.2 &&
1170 rm -rf SANETESTD.1 SANETESTD.2 ||
1171 error "bug in test sript: cannot clean SANETESTD"
1172 return $status
1173'
Jeff Kingf838ce52013-03-10 21:31:47 -04001174
Johannes Schindelind98b2c52016-07-21 18:02:54 +02001175test FreeBSD != $uname_s || GIT_UNZIP=${GIT_UNZIP:-/usr/local/bin/unzip}
Jeff Kingf838ce52013-03-10 21:31:47 -04001176GIT_UNZIP=${GIT_UNZIP:-unzip}
1177test_lazy_prereq UNZIP '
1178 "$GIT_UNZIP" -v
1179 test $? -ne 127
1180'
Jeff King9a308de2015-03-13 00:53:07 -04001181
1182run_with_limited_cmdline () {
1183 (ulimit -s 128 && "$@")
1184}
1185
Ramsay Jones21dac1d2017-09-14 18:24:41 +01001186test_lazy_prereq CMDLINE_LIMIT '
1187 test_have_prereq !MINGW,!CYGWIN &&
1188 run_with_limited_cmdline true
1189'
Jeff King6b9c38e2016-07-11 19:54:18 -04001190
Michael J Gruber4db464f2017-09-07 16:02:20 +02001191run_with_limited_stack () {
1192 (ulimit -s 128 && "$@")
1193}
1194
Ramsay Jones21dac1d2017-09-14 18:24:41 +01001195test_lazy_prereq ULIMIT_STACK_SIZE '
1196 test_have_prereq !MINGW,!CYGWIN &&
1197 run_with_limited_stack true
1198'
Michael J Gruber4db464f2017-09-07 16:02:20 +02001199
Jeff King6b9c38e2016-07-11 19:54:18 -04001200build_option () {
1201 git version --build-options |
1202 sed -ne "s/^$1: //p"
1203}
1204
1205test_lazy_prereq LONG_IS_64BIT '
1206 test 8 -le "$(build_option sizeof-long)"
1207'
Johannes Schindelina07fb052017-04-20 22:52:13 +02001208
1209test_lazy_prereq TIME_IS_64BIT 'test-date is64bit'
Johannes Schindelinefac8ac2017-04-20 22:58:21 +02001210test_lazy_prereq TIME_T_IS_64BIT 'test-date time_t-is64bit'